/*******************************************************************************
 * CS559 Spring 2008 - Project 2 - Trains and Roller Coasters
 *
 * Example Solution, by Chi Man Liu
 * begin 3/13/2008
 *
 * File: Track.cpp
 * Implements the Track class.
 ******************************************************************************/
#include "Track.h"

// the FlTk headers have lots of warnings - these are bad, but there's not
// much we can do about them. We enclose the #include's by #pragma's to
// suppress warnings generated by the Fltk library.
#pragma warning(push)
#pragma warning(disable:4311)		// convert void* to long
#pragma warning(disable:4312)		// convert long to void*
#include <Fl/gl.h>
#pragma warning(pop)

// for trigonometry
#include <cmath>

#define PI 3.14169

// constructor. default r is 10.0
Track::Track(double r) {
	radius = r;
}

// destructor
Track::~Track() {
	// empty right now
}

// get the position of train on the track at time t (0 <= t <= 1).
// store the result in variables x, y and z.
void Track::positionAtTime(double t, double &x, double &y, double &z) {
	// simple trigonometry
	x = cos(t * 2 * PI) * radius;
	y = sin(t * 2 * PI) * radius;
	z = 1.0;
}

// get the direction vector of train on the track at time t (0 <= t <= 1).
// store the result in variables x, y and z.
void Track::directionAtTime(double t, double &x, double &y, double &z) {
	// find the tangent
	x = -sin(t * 2 * PI);
	y = cos(t * 2 * PI);
	z = 0.0;
}

// draw the track
void Track::draw() {
	// we approximate the circle by many short straight segments.
	// here we use 50 segments. (equivalently, a regular 50-sided polygon.)
	const int numSegments = 50;

	// we are going to draw a bunch of line segments.
	// each line segment is specified by its two endpoints.
	glBegin(GL_LINES);

	// white
	glColor3d(1.0, 1.0, 1.0);

	// draw lines
	for (int i = 0; i < numSegments; ++i) {
		// one endpoint
		glVertex3d(cos(i * 2 * PI / numSegments) * radius,
			sin(i * 2 * PI / numSegments) * radius,
			1.0f);
		// the other endpoint
		glVertex3d(cos((i+1) * 2 * PI / numSegments) * radius,
			sin((i+1) * 2 * PI / numSegments) * radius,
			1.0f);
	}

	glEnd();
}
