/*******************************************************************************
 * CS559 Spring 2008 - Project 2 - Trains and Roller Coasters
 *
 * Example Solution, by Chi Man Liu
 * begin 3/13/2008
 *
 * File: Track.h
 * The Track class represents a track (with a starting point). While in the
 * sample solution the track is just a simple circle, it can be much more
 * complicated in your final project delivery. In general, a track class
 * should provide functions such as:
 *   draw: since the track is specified by a lot of control points and can be
 *         highly complex, it should have its own draw method.
 *   where-is-the-train-at-time-t: since we are animating the train, we need to
 *         know its position after some given amount of time from the starting
 *         point.
 ******************************************************************************/
#ifndef TRACK_H
#define TRACK_H

// This class represents a circular track centered at (0,0,1) with radius r.
// Assumption: train takes 1 unit of time to complete one loop.
class Track {
public:
	// constructor
	Track(double r = 10.0);
	// destructor
	~Track();
	// get the position of train on the track at time t (0 <= t <= 1)
	void positionAtTime(double t, double &x, double &y, double &z);
	// get the direction vector of train on the track at time t (0 <= t <= 1)
	void directionAtTime(double t, double &x, double &y, double &z);
	// draw the track
	void draw();
private:
	// radius of our circular track
	double radius;
};

#endif
